#ifndef pfodBufferedClient_h
#define pfodBufferedClient_h
/**
 (c)2015 Forward Computing and Control Pty. Ltd.
 This code may be freely used for both private and commerical use.
 Provide this copyright is maintained.
*/

#include "Stream.h"
#include <Client.h>
class pfodBufferedClient : public Stream {

  public:
    pfodBufferedClient(); // default 1456 byte buffer and default send delay 10mS 
    pfodBufferedClient* connect(Client* _client);  
    virtual size_t write(uint8_t);
    virtual size_t write(const uint8_t *buf, size_t size);
    virtual int available();
    virtual int read();
    virtual int peek();
    virtual void flush();   
    virtual void stop();
    virtual uint8_t connected();
    void setDebugStream(Print* out);
  private:
    Client* client;
    void sendAfterDelay();
    void forceSend();
    size_t _write(uint8_t c);
    static const unsigned long DEFAULT_SEND_DELAY_TIME = 10; // 10mS delay before sending buffer
    static const size_t DEFAULT_SEND_BUFFER_SIZE = 1434; // Max data size for standard TCP/IP packet 1500 - 64
    uint8_t sendBuffer[DEFAULT_SEND_BUFFER_SIZE]; //
    size_t sendBufferIdx = 0;
    unsigned long sendTimerStart = 0;
    unsigned long sendDelayTime;
    Print* debugOut;
};

#endif // pfodBufferedClient_h
